config/routes.rb
Rails.application.routes.draw do
  devise_for :admin_users, controllers: { sessions: 'sessions' }
  namespace :admin do
    root to: 'dashboard#index'

    resources :static_pages
    resources :reviews
    resources :users
    resources :portfolios
    resources :videos
    resources :articles
    resources :subcategories
    resources :categories
    resources :vendors
  end

  mount API::Base, at: '/'

  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/admin_user.rb
class AdminUser < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable
end

app/models/api_key.rb
class ApiKey < ApplicationRecord
  attr_accessor :application
  before_create :generate_access_token
  before_create :set_expiration
  belongs_to :user

  def expired?
    DateTime.now >= self.expires_at
  end

  private
  def generate_access_token
    begin
      self.access_token = SecureRandom.hex
    end while self.class.exists?(access_token: access_token)
  end

  def set_expiration
    self.expires_at = DateTime.now+30
  end
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/article.rb
class Article < ApplicationRecord

  validates :title, presence: true, length: { maximum: 255 }
  validates :content, presence: true
  validates :image, presence: true

  mount_uploader :image, ArticleImageUploader

  default_scope -> { order(:id) }

end

app/models/category.rb
class Category < ApplicationRecord
  has_many :subcategories
  has_many :vendors

  validates :title, presence: true, length: { maximum: 255 }
  validates :image, presence: true

  mount_uploader :image, CategoryImageUploader
end

app/models/portfolio.rb
class Portfolio < ApplicationRecord
  belongs_to :vendor

  validates :vendor_id, presence: true
  validates :image, presence: true

  mount_uploader :image, PortfolioImageUploader
end

app/models/review.rb
class Review < ApplicationRecord
  belongs_to :user, required: false
  belongs_to :vendor, required: false

  validates :user_id, presence: true
  validates :vendor_id, presence: true
  validates :review, presence: true,
    numericality: { only_integer: true, less_than_or_equal_to: 5, greater_than_or_equal_to: 1 }

  after_save :update_vendor

  def update_vendor
    vendor = Vendor.select('avg(reviews.review) AS average_review, count(reviews.id) AS reviews_count')
            .joins('LEFT JOIN reviews ON vendors.id = reviews.vendor_id')
            .where("vendors.id = #{vendor_id}").first

    self.vendor.update!(average_review: vendor[:average_review], reviews_count: vendor[:reviews_count])
  end
end

app/models/static_page.rb
class StaticPage < ApplicationRecord
  validates :name, presence: true, length: { maximum: 100 }

end

app/models/subcategory.rb
class Subcategory < ApplicationRecord
  belongs_to :category, required: false
  has_many :vendors

  validates :title, presence: true, length: { maximum: 255 }
  validates :category_id, presence: true
end

app/models/user.rb
require 'bcrypt'

class User < ApplicationRecord
  has_secure_password

  validates :username,
    presence: true,
    length: { maximum: 100 },
    uniqueness: true

  validates :email,
    presence: true,
    length: { maximum: 255 },
    uniqueness: true
end

app/models/vendor.rb
class Vendor < ApplicationRecord
  belongs_to :category, required: false
  belongs_to :subcategory, required: false
  has_many :portfolios
  has_many :reviews

  validates :title, presence: true, length: { maximum: 100 }
  validates :contact_number, presence: true, length: { maximum: 30 }
  validates :address, presence: true, length: { maximum: 255 }
  validates :fb_page_url, presence: true, length: { maximum: 255 }
  validates :budget, presence: true, numericality: { only_integer: true }
  validates :category_id, presence: true
  validates :image, presence: true

  mount_uploader :image, VendorImageUploader

  scope :vendors_with_reviews, lambda { |category_id: nil, subcategory_id: nil, average_review: nil, budget_from: nil, budget_to: nil|
    query = all
    query = query.where(category_id: category_id) unless category_id.nil?
    query = query.where(subcategory_id: subcategory_id) unless subcategory_id.nil?
    unless average_review.nil?
     query = query.where("average_review >= #{average_review}")
    end
    query = query.where("budget >= #{budget_from}") unless budget_from.nil?
    query = query.where("budget <= #{budget_to}") unless budget_to.nil?

    query
  }
end

app/models/video.rb
class Video < ApplicationRecord

  validates :title, presence: true, length: { maximum: 255 }
  validates :content, presence: true
  validates :video, presence: true

  mount_uploader :video, VideoUploader
end

app/controllers/admin/users_controller.rb
module Admin
  class UsersController < AdminController
    before_action :set_user, only: %i[show edit update destroy]

    # GET /users
    # GET /users.json
    def index
      @users = User.all
    end

    # GET /users/1
    # GET /users/1.json
    def show; end

    # GET /users/new
    def new
      @user = User.new
    end

    # GET /users/1/edit
    def edit; end

    # POST /users
    # POST /users.json
    def create
      @user = User.new(user_params)

      respond_to do |format|
        if @user.save
          format.html { redirect_to admin_user_url(@user), notice: 'User was successfully created.' }
          format.json { render :show, status: :created, location: @user }
        else
          format.html { render :new }
          format.json { render json: @user.errors, status: :unprocessable_entity }
        end
      end
    end

    # PATCH/PUT /users/1
    # PATCH/PUT /users/1.json
    def update
      respond_to do |format|
        if @user.update(user_params)
          format.html { redirect_to admin_user_url(@user), notice: 'User was successfully updated.' }
          format.json { render :show, status: :ok, location: @user }
        else
          format.html { render :edit }
          format.json { render json: @user.errors, status: :unprocessable_entity }
        end
      end
    end

    # DELETE /users/1
    # DELETE /users/1.json
    def destroy
      @user.destroy
      respond_to do |format|
        format.html { redirect_to admin_users_url, notice: 'User was successfully destroyed.' }
        format.json { head :no_content }
      end
    end

    private

    # Use callbacks to share common setup or constraints between actions.
    def set_user
      @user = User.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def user_params
      params.require(:user).permit(:username, :email, :password)
    end
  end
end

app/controllers/api/entities/user.rb
module API
  module Entities
    class User < Grape::Entity
      expose :username
    end
  end
end

app/controllers/api/v1/users.rb
module API
  module V1
    class Users < Grape::API
      include API::V1::Defaults

      resource :users do
        desc 'sign up'
        params do
          requires :username, type: String, desc: 'Username'
          requires :email, type: String, desc: 'E-mail'
          requires :password, type: String, desc: 'Password'
        end
        post 'sign_up', root: :users do
          User.create(username: permitted_params[:username],
            email: permitted_params[:email], password: permitted_params[:password])
        end

        desc 'change_password'
        params do
          requires :new_password, type: String, desc: 'New Password'
        end
        patch 'change_password', root: :users do
          authenticate!

          current_user.update(password: permitted_params[:new_password])
        end
      end
    end
  end
end

app/helpers/application_helper.rb
require 'uri'

module ApplicationHelper
  def is_active(page_name)
    uri = URI(request.original_url)
    page_name == uri.path.split('/')[2]
  end
end

app/helpers/articles_helper.rb
module ArticlesHelper
end

app/helpers/categories_helper.rb
module CategoriesHelper
end

app/helpers/portfolios_helper.rb
module PortfoliosHelper
end

app/helpers/reviews_helper.rb
module ReviewsHelper
end

app/helpers/static_pages_helper.rb
module StaticPagesHelper
end

app/helpers/subcategories_helper.rb
module SubcategoriesHelper
end

app/helpers/users_helper.rb
module UsersHelper
end

app/helpers/vendors_helper.rb
module VendorsHelper
end

app/helpers/videos_helper.rb
module VideosHelper
end

app/views/admin/users/_form.html.slim
= form_for [:admin, @user] do |f|
  - if @user.errors.any?
    #error_explanation
      h2 = "#{pluralize(@user.errors.count, "error")} prohibited this user from being saved:"
      ul
        - @user.errors.full_messages.each do |message|
          li = message

  .field
    = f.label :username
    = f.text_field :username, class: "form-control"
  .field
    = f.label :email
    = f.text_field :email, class: "form-control"
  .field
    = f.label :password
    = f.text_field :password, class: "form-control"
  .actions
    = f.submit "Submit", :class => "btn btn-primary"

app/views/admin/users/edit.html.slim
h1 Editing user

== render 'form'

=> link_to 'Show', admin_user_path(@user)
'|
=< link_to 'Back', admin_users_path

app/views/admin/users/index.html.slim
section.content-header
  h1 Manage Users

section.content
  div.box
    div.box-header.with-border
      h3.box-title List

    div.box-body
      table.table.table-bordered.table-hover
        thead
          tr
            th Username
            th style="width:10em" E-mail
            th colspan="3"
        tbody
          - @users.each do |user|
            tr
              td
                = user.username
              td
                = user.email
              td style="width:7em"
                = fa_icon "eye"
                = link_to "View", admin_user_path(user)
              td style="width:7em"
                = fa_icon "pencil"
                = link_to "Edit", edit_admin_user_path(user)
              td style="with:7em"
                = fa_icon "remove"
                = link_to "Delete", admin_user_path(user), method: :delete, data: { confirm: "This record will be deleted. Are you sure?" }
      br
      = link_to 'New User', new_admin_user_path, { class: "btn btn-default" }

app/views/admin/users/new.html.slim
h1 New user

== render 'form'

= link_to 'Back', admin_users_path

app/views/admin/users/show.html.slim
p#notice = notice

p
  strong Username:
  = @user.username
p
  strong Email:
  = @user.email
p
  strong Password:
  = @user.password

=> link_to 'Edit', edit_admin_user_path(@user)
'|
=< link_to 'Back', admin_users_path